<template>
  <div>
    <div
      id="modal_tipo_animal_crear"
      class="modal fade"
      tabindex="-1"
      aria-hidden="true"
      data-bs-backdrop="static"
      data-bs-keyboard="false"
    >
      <div class="modal-dialog mw-650px">
        <div
          id="modal_tipo_animal_crear_formulario"
          class="modal-content rounded"
        >
          <div class="modal-header">
            <h3 class="modal-title">
              Registrar un nuevo tipo de animal
            </h3>

            <div
              id="modal_tipo_animal_crear_btn_cerrar"
              class="btn btn-icon btn-sm btn-active-light-primary ms-2"
              data-bs-dismiss="modal"
              aria-label="Close"
              @click="onCerrarModal()"
            >
              <i class="bi bi-x-lg" />
            </div>
          </div>

          <div class="modal-body scroll-y px-10 px-lg-15 pt-0 pb-0">
            <div class="row">
              <div class="col-xxl-12 col-form-label">
                <label class="required fw-bolder fs-6">Nombre</label>
              </div>
              <div class="col-xxl-12">
                <input
                  v-model="mFormulario.nombre"
                  type="text"
                  class="form-control"
                  placeholder=""
                  maxlength="100"
                >
              </div>
            </div>

            <div class="row">
              <div class="col-xxl-12 col-form-label">
                <label class="required fw-bolder fs-6">Logo
                  <i
                    class="fas fa-exclamation-circle ms-2 fs-7"
                    data-bs-toggle="tooltip"
                    title="La imagen debe tener una dimensión de 500px de ancho y 500px de alto."
                    data-bs-original-title="La imagen debe tener una dimensión de 500px de ancho y 500px de alto."
                    aria-label="La imagen debe tener una dimensión de 500px de ancho y 500px de alto."
                  />
                </label>
              </div>
              <div class="col-xxl-12">
                <div
                  id="modal_tipo_animal_crear_ktinputimagen"
                  class="image-input  image-input-empty"
                  style="background-image: url('/cebusk/media/img/anadir-imagen.png')"
                >
                  <div class="image-input-wrapper w-125px h-125px" />

                  <label
                    class="btn btn-icon btn-circle btn-active-color-primary w-25px h-25px bg-white shadow"
                    data-kt-image-input-action="change"
                    data-bs-toggle="tooltip"
                    data-bs-dismiss="click"
                    title="Cambiar imagen"
                  >
                    <i class="bi bi-pencil-fill fs-7" />

                    <input
                      type="file"
                      name="avatar"
                      accept=".png, .jpg, .jpeg"
                    >

                    <input
                      type="hidden"
                      name="avatar_remove"
                    >
                  </label>
                  <span
                    class="btn btn-icon btn-circle btn-active-color-primary w-25px h-25px bg-white shadow"
                    data-kt-image-input-action="cancel"
                    data-bs-toggle="tooltip"
                    data-bs-dismiss="click"
                    title="Cancelar imagen"
                  >
                    <i class="bi bi-x fs-2" />
                  </span>
                  <span
                    id="modal_tipo_animal_crear_ktinputimagen_eliminar"
                    class="btn btn-icon btn-circle btn-active-color-primary w-25px h-25px bg-white shadow"
                    data-kt-image-input-action="remove"
                    data-bs-toggle="tooltip"
                    data-bs-dismiss="click"
                    title="Eliminar imagen"
                  >
                    <i class="bi bi-x fs-2" />
                  </span>
                </div>
              </div>
            </div>
          </div>

          <div class="modal-footer px-10 py-5">
            <button
              type="button"
              class="btn btn-secondary"
              data-bs-dismiss="modal"
              @click="onCerrarModal()"
            >
              Cancelar
            </button>
            <button
              id="modal_tipo_animal_crear_btn_guardar"
              type="button"
              class="btn btn-primary"
              @click="onTipoAnimalRegistrar()"
            >
              <span class="indicator-label">Guardar</span>
              <span class="indicator-progress">
                Espere por favor... <span class="spinner-border spinner-border-sm align-middle ms-2" />
              </span>
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import InputImagen from "@/core/util/InputImagen";
import BloqueoUI from "@/core/util/BloqueoUI";
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";
import Alerta from "@/core/util/Alerta";

export default {
  name: 'ModalTipoAnimalCrear',
  components: {
  },
  emits: ['onTipoAnimalListar'],

  data() {
    return {
      componentes: {
        inputImagen: null,
        bloqueoUI: null,
      },
      mFormulario: {
        nombre: '',
        foto: null,
      }
    };
  },

  mounted() {
    this.componentes.inputImagen = new InputImagen('#modal_tipo_animal_crear_ktinputimagen');
    this.componentes.bloqueoUI = new BloqueoUI('#modal_tipo_animal_crear_formulario', '#modal_tipo_animal_crear_btn_guardar');
  },
  methods: {
    onTipoAnimalRegistrar() {
      this.mFormulario.foto = this.componentes.inputImagen.imagen;

      this.componentes.bloqueoUI.iniciarBloqueoFormulario();
      Servicio.postMultiPart(Ruta.PANEL_TIPO_ANIMAL_REGISTRAR, this.mFormulario).then( (data) => {
        Toast.mostrarExito(data.mensaje);
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        this.$emit('onTipoAnimalListar');
        this.cerrarModal();
      }).catch((error) => {
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        Alerta.alertaError(error);
      });
    },

    onCerrarModal() {
      this.mFormulario = {nombre: '', foto: null};
      this.componentes.inputImagen.limpiar();
    },

    cerrarModal() {
      document.querySelector('#modal_tipo_animal_crear_btn_cerrar').click();
    }
  }
}
</script>